Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.gui
Class QItemDelegate

    java.lang.Object
      com.trolltech.qt.QSignalEmitter
          com.trolltech.qt.QtJambiObject
              com.trolltech.qt.core.QObject
                  com.trolltech.qt.gui.QAbstractItemDelegate
                      com.trolltech.qt.gui.QItemDelegate

All Implemented Interfaces:
  QtJambiInterface

    public class QItemDelegate

extends QAbstractItemDelegate

The `QItemDelegate` class provides display and editing facilities for data items from a model. `QItemDelegate` can be used to provide custom display features and editor widgets for item views based on `QAbstractItemView` subclasses. Using a delegate for this purpose allows the display and editing mechanisms to be customized and developed independently from the model and view.

The `QItemDelegate` class is one of the Model/View Classes and is part of Qt's model/view framework.

When displaying items from a custom model in a standard view, it is often sufficient to simply ensure that the model returns appropriate data for each of the `roles` that determine the appearance of items in views. The default delegate used by Qt's standard views uses this role information to display items in most of the common forms expected by users. However, it is sometimes necessary to have even more control over the appearance of items than the default delegate can provide.

This class provides default implementations of the functions for painting item data in a view and editing data from item models. Default implementations of the `paint()` and `sizeHint()` virtual functions, defined in `QAbstractItemDelegate`, are provided to ensure that the delegate implements the correct basic behavior expected by views. You can reimplement these functions in subclasses to customize the appearance of items.

When editing data in an item view, `QItemDelegate` provides an editor widget, which is a widget that is placed on top of the view while editing takes place. Editors are created with a `QItemEditorFactory`; a default static instance provided by `QItemEditorFactory` is installed on all item delagates. You can set a custom factory using `setItemEditorFactory()` or set a new default factory with `QItemEditorFactory::setDefaultFactory()`. It is the data stored in the item model with the `Qt::EditRole` that is edited.

Only the standard editing functions for widget-based delegates are reimplemented here:

- `createEditor()` returns the widget used to change data from the model and can be reimplemented to customize editing behavior.
- `setEditorData()` provides the widget with data to manipulate.
- `updateEditorGeometry()` ensures that the editor is displayed correctly with respect to the item view.
- `setModelData()` returns updated data to the model.

The `closeEditor()` signal indicates that the user has completed editing the data, and that the editor widget can be destroyed.

## Standard Roles and Data Types

The default delegate used by the standard views supplied with Qt associates each standard role (defined by `Qt::ItemDataRole` ) with certain data types. Models that return data in these types can influence the appearance of the delegate as described in the following table.

Role | Accepted Types
--- | ---
`Qt::BackgroundRole` | `QBrush`
`Qt::BackgroundColorRole` | `QColor` (obsolete; use `Qt::BackgroundRole` instead)
`Qt::CheckStateRole` | `Qt::CheckState`
`Qt::DecorationRole` | `QIcon` and `QColor`
`Qt::DisplayRole` | QString and types with a string representation
`Qt::EditRole` | See `QItemEditorFactory` for details
`Qt::FontRole` | `QFont`
`Qt::SizeHintRole` | `QSize`
`Qt::TextAlignmentRole` | Qt::Alignment
`Qt::ForegroundRole` | `QBrush`
`Qt::TextColorRole` | `QColor` (obsolete; use `Qt::ForegroundRole` instead)

If the default delegate does not allow the level of customization that you need, either for display purposes or for editing data, it is possible to subclass `QItemDelegate` to implement the desired behavior.

## Subclassing

When subclassing `QItemDelegate` to create a delegate that displays items using a custom renderer, it is important to ensure that the delegate can render items suitably for all the required states; e.g. selected, disabled, checked. The documentation for the `paint()` function contains some hints to show how this can be achieved.

You can provide custom editors by using a `QItemEditorFactory`. The Color Editor Factory Example shows how a custom editor can be made available to delegates with the default item editor factory. This way, there is no need to subclass `QItemDelegate`. An alternative is to reimplement `createEditor()`, `setEditorData()`, `setModelData()`, and `updateEditorGeometry()`. This process is described in the Spin Box Delegate example.

See also:
  Delegate Classes, `QStyledItemDelegate`, `QAbstractItemDelegate`, Spin Box Delegate Example, Settings Editor Example, and Icons Example.

Nested Class Summary

Nested classes/interfaces inherited from class com.trolltech.qt.gui.QAbstractItemDelegate
`QAbstractItemDelegate.EndEditHint`

Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter
`QSignalEmitter.Signal0, QSignalEmitter.Signal1, QSignalEmitter.Signal2, QSignalEmitter.Signal3, QSignalEmitter.Signal4, QSignalEmitter.Signal5, QSignalEmitter.Signal6, QSignalEmitter.Signal7, QSignalEmitter.Signal8, QSignalEmitter.Signal9`

Field Summary

Fields inherited from class com.trolltech.qt.gui.QAbstractItemDelegate
`closeEditor, commitData, sizeHintChanged`

Constructor Summary
`QItemDelegate()` Constructs an item delegate with the given `parent`.
`QItemDelegate(QObject parent)` Constructs an item delegate with the given `parent`.

Method Summary
`protected void` | `drawBackground(QPainter painter, QStyleOptionViewItem option, QModelIndex index)` Renders the item background for the given `index`, using the given `painter` and style `option`.
`protected void` | `drawCheck(QPainter painter, QStyleOptionViewItem option, QRect rect, Qt.CheckState state)` Renders a check indicator within the rectangle specified by `rect`, using the given `painter` and style `option`, using the given `state`.
`protected void` | `drawDecoration(QPainter painter, QStyleOptionViewItem option, QRect rect, QPixmap pixmap)` Renders the decoration `pixmap` within the rectangle specified by `rect` using the given `painter` and style `option`.
`protected void` | `drawDisplay(QPainter painter, QStyleOptionViewItem option, QRect rect, java.lang.String text)` Renders the item view `text` within the rectangle specified by `rect` using the given `painter` and style `option`.
`protected void` | `drawFocus(QPainter painter, QStyleOptionViewItem option, QRect rect)` Renders the region within the rectangle specified by `rect`, indicating that it has the focus, using the given `painter` and style `option`.
`static QItemDelegate` | `fromNativePointer(QNativePointer nativePointer)` This method returns the QItemDelegate instance pointed to by `nativePointer`.
`boolean` | `hasClipping()` This property holds if the delegate should clip the paint events.
`QItemEditorFactory` | `itemEditorFactory()` Returns the editor factory used by the item delegate.
`void` | `setClipping(boolean clip)` This property holds if the delegate should clip the paint events.
`void` | `setItemEditorFactory(QItemEditorFactory factory)` Sets the editor factory to be used by the item delegate to be the `factory` specified.

Methods inherited from class com.trolltech.qt.gui.QAbstractItemDelegate
`createEditor, editorEvent, helpEvent, paint, setEditorData, setModelData, sizeHint, updateEditorGeometry`

Methods inherited from class com.trolltech.qt.core.QObject
`childEvent, children, connectSlotsByName, customEvent, disposeLater, dumpObjectInfo, dumpObjectTree, dynamicPropertyNames, event, eventFilter, findChild, findChild, findChild, findChildren, findChildren, findChildren, findChildren, indexOfProperty, installEventFilter, isWidgetType, killTimer, moveToThread, objectName, parent, properties, property, removeEventFilter, setObjectName, setParent, setProperty, startTimer, timerEvent, toString, userProperty`

Methods inherited from class com.trolltech.qt.QtJambiObject
`dispose, disposed, equals, finalize, reassignNativeResources, tr, tr, tr`

Methods inherited from class com.trolltech.qt.QSignalEmitter
`blockSignals, disconnect, disconnect, signalsBlocked, signalSender, thread`

Methods inherited from class java.lang.Object
`clone, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Constructor Detail

### QItemDelegate

    public QItemDelegate()

  Constructs an item delegate with the given `parent`.

### QItemDelegate

    public QItemDelegate(QObject parent)

  Constructs an item delegate with the given `parent`.

Method Detail

### drawBackground

    protected final void drawBackground(QPainter painter,
                                        QStyleOptionViewItem option,
                                        QModelIndex index)

  Renders the item background for the given `index`, using the given `painter` and style `option`.

### hasClipping

    public final boolean hasClipping()

  This property holds if the delegate should clip the paint events. This property will set the paint clip to the size of the item. The default value is on. It is useful for cases such as when images are larger than the size of the item.

### itemEditorFactory

    public final QItemEditorFactory itemEditorFactory()

  Returns the editor factory used by the item delegate. If no editor factory is set, the function will return null.

See also:
  `setItemEditorFactory()`.

### setClipping

    public final void setClipping(boolean clip)

  This property holds if the delegate should clip the paint events. This property will set the paint clip to the size of the item. The default value is on. It is useful for cases such as when images are larger than the size of the item.

### setItemEditorFactory

    public final void setItemEditorFactory(QItemEditorFactory factory)

  Sets the editor factory to be used by the item delegate to be the `factory` specified. If no editor factory is set, the item delegate will use the default editor factory.

See also:
  `itemEditorFactory()`.

### drawCheck

    protected void drawCheck(QPainter painter,
                             QStyleOptionViewItem option,
                             QRect rect,
                             Qt.CheckState state)

  Renders a check indicator within the rectangle specified by `rect`, using the given `painter` and style `option`, using the given `state`.

### drawDecoration

    protected void drawDecoration(QPainter painter,
                                  QStyleOptionViewItem option,
                                  QRect rect,
                                  QPixmap pixmap)

  Renders the decoration `pixmap` within the rectangle specified by `rect` using the given `painter` and style `option`.

### drawDisplay

    protected void drawDisplay(QPainter painter,
                               QStyleOptionViewItem option,
                               QRect rect,
                               java.lang.String text)

  Renders the item view `text` within the rectangle specified by `rect` using the given `painter` and style `option`.

### drawFocus

    protected void drawFocus(QPainter painter,
                             QStyleOptionViewItem option,
                             QRect rect)

  Renders the region within the rectangle specified by `rect`, indicating that it has the focus, using the given `painter` and style `option`.

### fromNativePointer

    public static QItemDelegate fromNativePointer(QNativePointer nativePointer)

  This method returns the QItemDelegate instance pointed to by `nativePointer`.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD